#SingleInstance force
;If you have any questions, contact Selune in Meroe


!F1::
; Reload the script when you make changes
reload
return


!q::
; Emergency Quit
ExitApp
return


!s::
; Toggle hotkeys
suspend toggle
return


!m::
; Mine
Gui, Add, Text,, Metal to Mine:
Gui, Add, DropDownList, vmetal Choose2, iron|copper|tin
Gui, Add, Text,, Number of times to repeat:
Gui, Add, Edit, vnum_repeats wp, 50
Gui, Add, Text,, Mining timer (in seconds):
Gui, Add, Edit, vclick_delay wp, 5
Gui, Add, Text,, Round delay (memory game):
Gui, Add, DropDownList, vskill Choose1, 0|1|2|3|4|5|6
Gui, Add, Button, Default, MINE
Gui, Show
return


ButtonMINE:
Gui, Submit
; Validate input
if (!((num_repeats > 0) && (num_repeats <= 10000))) { 
	MsgBox "Please enter a number of repeats between 1 and 10000"
	Gui, Show
	return
}
if (!((click_delay >= 0) && (click_delay <= 7))) { 
	MsgBox "Please enter a mining timer between 0 and 7 seconds"
	Gui, Show
	return
}

; Make sure repeat is an integer
num_repeats //= 1

; Convert to miliseconds
click_delay *= 1000

; Change round delay to skill
skill += 1

Gui, Destroy
Mine()
return


Mine()
{
	global skill
	global metal
	global click_delay
	global num_repeats

	debug = 0
	round = 1
	crystal = 0

	; Get the locations of the crystals
	MsgBox "Move the mouse to each crystal, and press F1`nFor best results, choose a spot of equal lightness on each crystal"
	Loop 7 {
		KeyWait, F1, D
		KeyWait, F1
		crystal += 1
		MouseGetPos, Xtemp, Ytemp
		X%crystal% := Xtemp
		Y%crystal% := Ytemp
	}

	; Set some defaults in case you need to delay for higher skill levels
	i = 0
	Loop 7 {
		i += 1
		memory%i% = 4
	}

	; Do work
	Loop %num_repeats% {
		i = 0
		num = 0

		; Collect color information on all the crystals
		Loop 7 {
			i += 1
			PixelGetColor, color%i%, X%i%, Y%i%
			R%i% := color%i% & 0xFF0000
			R%i% >>= 16
			G%i% := color%i% & 0x00FF00
			G%i% >>= 8
			B%i% := color%i% & 0x0000FF
			Sleep 5

			;  Convert RGB into HSL (Hue, Saturation, Lightness)
			R%i% /= 255.0
			G%i% /= 255.0
			B%i% /= 255.0

			minimum%i% := Min(Min(R%i%, G%i%), B%i%)
			maximum%i% := Max(Max(R%i%, G%i%), B%i%)

			; Lightness
			lightness%i% := (minimum%i% + maximum%i%)/2

			; Saturation
			if (lightness%i% < .5) {
				saturation%i% := (maximum%i%-minimum%i%)/(maximum%i%+minimum%i%)
			} else {
				saturation%i% := (maximum%i%-minimum%i%)/(2.0-maximum%i%-minimum%i%)
			}

			; Hue
			if (R%i% == maximum%i%) {
				hue%i% := (G%i%-B%i%)/(maximum%i%-minimum%i%)
			} else if (G%i% == maximum%i%) {
				hue%i% := 2.0 + (B%i%-R%i%)/(maximum%i%-minimum%i%)
			} else if (B == maximum%i%) {
				hue%i% := 4.0 + (R%i%-G%i%)/(maximum%i%-minimum%i%)
			}

			if (hue%i% < 0) {
				hue%i% += 6
			}
		}

		; The "correct" crystal for copper is the one with the highest saturation
		if (metal == "copper") {
			i = 0
			max_sat = 0
			Loop 7 {
				i += 1
				if (saturation%i% > max_sat) {
					max_sat := saturation%i%
					num := i
				}
			}
		}

		; The hue which is most different from the others is correct
		if (metal == "iron") {
			i = 0
			big_d = 0
			hue_avg = 0
			; Loop over each crystal
			Loop 7 {
				i += 1
				hue_avg += hue%i%
			}
			hue_avg := hue_avg / 7
			
			i = 0
			Loop 7 {
				i += 1
				hue_diff := Abs(hue%i% - hue_avg)
				if (hue_diff > big_d) {
					big_d := hue_diff
					num := i
				}
			}	
		}

		if (metal == "tin") {

		}

		memory%round% := num
		round += 1
		if (round > skill) {
			round := 1
		}
		num := memory%round%

		if (debug) {
			Message := ""
			i = 0
			loop 7 {
				i += 1
				Message .= i . ": R=" . R%i% . ", G=" . G%i% . ", B=". B%i% . ", Avg=" . A%i%
					     . " H=" . hue%i% . " S=" . saturation%i% . " L=" . lightness%i% . "`n"
			}
			Message .= "Max is " . num . "`n`n"
			FileAppend, %Message%, C:\atitd.log
		}

		MouseMove, X%num%, Y%num%, 0
		Send w
		Sleep %click_delay%
	}
}


Max(x, y)
{
	return x > y ? x : y
}


Min(x ,y)
{
	return x < y ? x : y
}

GuiClose:
Gui, Destroy
return